Package com.sas.metadata.remote

# Interface NamedService

All Superinterfaces:
  `CMetadata`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `PrimaryType`, `Remote`, `Root`

public interface NamedService extends PrimaryType
Describes the name of the service and how the name is used (as rebind, bind, or lookup). This type is associated to one DeployedComponent that is being named, and to (possibly multiple) DeployedComponents that provide a naming service.

Attributes of NamedService are:

- `ServiceName`
- `Type`

Associations of NamedService are:

- `NamedComponent`
- `NamingServices`

## Usage

To create an instance of this NamedService, use the `factory` create methods.
Example: create a NamedService with name "NamedService_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     NamedService myObject = (NamedService) factory.createComplexMetadataObject(objectStore, "NamedService_Object", MetadataObjects.NAMEDSERVICE, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_NAMEDCOMPONENT_NAME`
  Constant used for the name of the NamedComponent association.
  `static final String`
  `ASSOCIATION_NAMINGSERVICES_NAME`
  Constant used for the name of the NamingServices association.
  `static final String`
  `ATTRIBUTE_SERVICENAME_NAME`
  Constant used for the name of the ServiceName attribute.
  `static final String`
  `ATTRIBUTE_TYPE_NAME`
  Constant used for the name of the Type attribute.

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.PrimaryType

  `ASSOCIATION_FAVORITESCONTAINERS_NAME, ATTRIBUTE_ISHIDDEN_NAME, ATTRIBUTE_PUBLICTYPE_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `DeployedComponent`
  `getNamedComponent()`
  Gets the `DeployedComponent` for `NamedComponent`
  `AssociationList`
  `getNamedComponents()`
  Gets the AssociationList of `NamedComponents`
  `AssociationList`
  `getNamedComponents(boolean fGoToServer)`
  Gets the Associationlist of `NamedComponents`
  `AssociationList`
  `getNamingServices()`
  Gets the AssociationList of `NamingServices`
  `AssociationList`
  `getNamingServices(boolean fGoToServer)`
  Gets the Associationlist of `NamingServices`
  `String`
  `getServiceName()`
  Gets the `String` value of `ServiceName`
  `int`
  `getServiceNameMaxLength()`
  Gets the maximum length of `ServiceName`
  `int`
  `getServiceNameState()`
  Gets the Metadata State of `ServiceName`
  `String`
  `getType()`
  Gets the `String` value of `Type`
  `int`
  `getTypeMaxLength()`
  Gets the maximum length of `Type`
  `int`
  `getTypeState()`
  Gets the Metadata State of `Type`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `NamedComponent`
  `NamingServices`
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `NamedComponent`
  `void`
  `setNamedComponent(DeployedComponent inObject)`
  Sets the `NamedComponents` list 0th element to be `inObject`.
  `void`
  `setNamedComponents(AssociationList list)`
  Sets the `NamedComponents` list to be `list`.
  `void`
  `setNamedComponents(AssociationList list, int state)`
  Sets the `NamedComponents` list to be `list`.
  `void`
  `setNamingServices(AssociationList list)`
  Sets the `NamingServices` list to be `list`.
  `void`
  `setNamingServices(AssociationList inObjects, int state)`
  Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
  `void`
  `setServiceName(String inServiceName)`
  Sets the `ServiceName` value and sets the state to MetadataState.LOCAL.
  `void`
  `setServiceName(String inServiceName, int state)`
  Sets the `ServiceName` Metadata State.
  `void`
  `setServiceNameState(int state)`
  Sets the Metadata State of `ServiceName`.
  `void`
  `setType(String inType)`
  Sets the `Type` value and sets the state to MetadataState.LOCAL.
  `void`
  `setType(String inType, int state)`
  Sets the `Type` Metadata State.
  `void`
  `setTypeState(int state)`
  Sets the Metadata State of `Type`.

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.PrimaryType

  `getFavoritesContainers, getFavoritesContainers, getIsHidden, getIsHiddenState, getPublicType, getPublicTypeMaxLength, getPublicTypeState, setFavoritesContainers, setFavoritesContainers, setIsHidden, setIsHidden, setIsHidden, setIsHidden, setIsHiddenState, setPublicType, setPublicType, setPublicTypeState`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_SERVICENAME_NAME

    static final String ATTRIBUTE_SERVICENAME_NAME
    Constant used for the name of the ServiceName attribute.

    ServiceName: ServiceName

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_TYPE_NAME

    static final String ATTRIBUTE_TYPE_NAME
    Constant used for the name of the Type attribute.

    Type: This is either Bind, Rebind, or Lookup.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_NAMEDCOMPONENT_NAME

    static final String ASSOCIATION_NAMEDCOMPONENT_NAME
    Constant used for the name of the NamedComponent association.

    NamedComponent: The component that is referenced using this name.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_NAMINGSERVICES_NAME

    static final String ASSOCIATION_NAMINGSERVICES_NAME
    Constant used for the name of the NamingServices association.

    NamingServices: The deployed component that act as a naming service and publish a service using this name.

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    `NamedComponent`
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `PrimaryType`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    `NamedComponent`
    `NamingServices`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `PrimaryType`
    Specified by:
      `initializePredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getServiceName

    String getServiceName() throws RemoteException
    Gets the `String` value of `ServiceName`
    Returns:
      The `ServiceName`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getServiceNameState

    int getServiceNameState() throws RemoteException
    Gets the Metadata State of `ServiceName`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getServiceNameMaxLength

    int getServiceNameMaxLength() throws RemoteException
    Gets the maximum length of `ServiceName`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getType

    String getType() throws RemoteException
    Gets the `String` value of `Type`
    Returns:
      The `Type`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getTypeState

    int getTypeState() throws RemoteException
    Gets the Metadata State of `Type`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getTypeMaxLength

    int getTypeMaxLength() throws RemoteException
    Gets the maximum length of `Type`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getNamedComponents

    AssociationList getNamedComponents() throws RemoteException, MdException
    Gets the AssociationList of `NamedComponents`
    Returns:
      Returns the AssociationList of `NamedComponents` which can be of type:
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException`

  - ### getNamedComponent

    DeployedComponent getNamedComponent() throws RemoteException, MdException
    Gets the `DeployedComponent` for `NamedComponent`
    Returns:
      The `DeployedComponent` ( `null` if not set) of `NamedComponent`which can be of type:
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getNamingServices

    AssociationList getNamingServices() throws RemoteException, MdException
    Gets the AssociationList of `NamingServices`
    Returns:
      Returns the AssociationList of `NamingServices` which can be of type:
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getNamedComponents

    AssociationList getNamedComponents(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `NamedComponents`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `NamedComponents` which can be of type:
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getNamingServices

    AssociationList getNamingServices(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `NamingServices`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `NamingServices` which can be of type:
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setServiceName

    void setServiceName(String inServiceName) throws RemoteException
    Sets the `ServiceName` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inServiceName` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setServiceName

    void setServiceName(String inServiceName, int state) throws RemoteException
    Sets the `ServiceName` Metadata State.
    Parameters:
      `inServiceName` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setServiceNameState

    void setServiceNameState(int state) throws RemoteException
    Sets the Metadata State of `ServiceName`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setType

    void setType(String inType) throws RemoteException
    Sets the `Type` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inType` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setType

    void setType(String inType, int state) throws RemoteException
    Sets the `Type` Metadata State.
    Parameters:
      `inType` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setTypeState

    void setTypeState(int state) throws RemoteException
    Sets the Metadata State of `Type`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setNamedComponents

    void setNamedComponents(AssociationList list) throws RemoteException
    Sets the `NamedComponents` list to be `list`. Object of which can be of type:
    DeployedComponent
    ConfiguredComponent
    ServiceComponent
    ServerComponent
    LogicalServer
    ServerContext
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setNamedComponents

    void setNamedComponents(AssociationList list, int state) throws RemoteException
    Sets the `NamedComponents` list to be `list`. Object of which can be of type:
    DeployedComponent
    ConfiguredComponent
    ServiceComponent
    ServerComponent
    LogicalServer
    ServerContext
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setNamedComponent

    void setNamedComponent(DeployedComponent inObject) throws RemoteException
    Sets the `NamedComponents` list 0th element to be `inObject`.
    Parameters:
      `inObject` - DeployedComponent
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setNamingServices

    void setNamingServices(AssociationList list) throws RemoteException
    Sets the `NamingServices` list to be `list`. Objects of which can be of type:
    DeployedComponent
    ConfiguredComponent
    ServiceComponent
    ServerComponent
    LogicalServer
    ServerContext
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setNamingServices

    void setNamingServices(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.